
#ifndef _MANAGEMENT_PROCESSOR_
#define _MANAGEMENT_PROCESSOR_

//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/management/ManagementObject.h"
#include "qpid/framing/FieldTable.h"
#include "qpid/framing/Uuid.h"

namespace qpid {
    namespace management {
        class ManagementAgent;
    }
}

namespace qmf {
namespace com {
namespace redhat {
namespace matahari {
namespace host {


class Processor : public ::qpid::management::ManagementObject
{
  private:

    static std::string packageName;
    static std::string className;
    static uint8_t     md5Sum[16];


    // Properties
    ::qpid::management::ObjectId host;
    uint8_t wordsize;
    std::string model;
    uint8_t count;
    uint8_t cores;

    // Statistics


    // Private Methods
    static void writeSchema(::qpid::framing::Buffer& buf);
    void writeProperties(::qpid::framing::Buffer& buf);
    void writeStatistics(::qpid::framing::Buffer& buf,
                         bool skipHeaders = false);
    void doMethod(std::string& methodName,
                  ::qpid::framing::Buffer& inBuf,
                  ::qpid::framing::Buffer& outBuf);
    writeSchemaCall_t getWriteSchemaCall() { return writeSchema; }

    // Stub for getInstChanged.  There are no statistics in this class.
    bool getInstChanged() { return false; }
    bool hasInst() { return false; }

  public:

    Processor(::qpid::management::ManagementAgent* agent,
                            ::qpid::management::Manageable* coreObject);
    ~Processor();

    

    static void registerSelf(::qpid::management::ManagementAgent* agent);
    std::string& getPackageName() const { return packageName; }
    std::string& getClassName() const { return className; }
    uint8_t* getMd5Sum() const { return md5Sum; }

    // Method IDs

    // Accessor Methods
    inline void set_host (const ::qpid::management::ObjectId& val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        host = val;
        configChanged = true;
    }
    inline const ::qpid::management::ObjectId& get_host() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return host;
    }
    inline void set_wordsize (uint8_t val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        wordsize = val;
        configChanged = true;
    }
    inline uint8_t get_wordsize() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return wordsize;
    }
    inline void set_model (const std::string& val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        model = val;
        configChanged = true;
    }
    inline const std::string& get_model() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return model;
    }
    inline void set_count (uint8_t val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        count = val;
        configChanged = true;
    }
    inline uint8_t get_count() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return count;
    }
    inline void set_cores (uint8_t val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        cores = val;
        configChanged = true;
    }
    inline uint8_t get_cores() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return cores;
    }

};

}}}}}

#endif  /*!_MANAGEMENT_PROCESSOR_*/
